#!/usr/bin/perl
#!C:\perl\bin\perl.exe
=Copyright Infomation
==========================================================
    Program Name    : Mewsoft GD Test
    Program Author   : Elsheshtawy, A. A.
    Home Page          : http://www.mewsoft.com
	File Version         : 2
	Copyrights  2004-2005 Mewsoft Corporation. All rights reserved.
==========================================================
=cut
#==========================================================
$| = 1;
print "Content-type: text/html\n\n";
use CGI::Carp qw(fatalsToBrowser); 
#==========================================================
BEGIN{use Cwd;}
$Global{CGI_Dir} = cwd;
#==========================================================
BEGIN {
			unshift @INC, ".";
			$0 = $^X unless ($^X =~ m%(^|[/\\])(perl)|(perl.exe)$%i);
			$Cwd = ".";
			if ($0 =~ m%^(.*)[/\\]%){$Cwd=$1; unshift @INC, $Cwd;};
			
			if (! $Global{CGI_Dir}) {
						$0 = $^X unless ($^X =~ m%(^|[/\\])(perl)|(perl.exe)$%i);
						if ($0 =~ m%^(.*)[/\\]%){$Global{CGI_Dir}=$1};
						if (!-d $Global{CGI_Dir}) {
								$Global{CGI_Dir} = "";
								$Temp = $ENV{SCRIPT_FILENAME};
								@Temp = split (/[\/\\]/, $Temp);
								pop @Temp;
								$Temp = join ('/', @Temp);
								if (-d $Temp) {$Global{CGI_Dir}=$Temp;}
						}
						$Global{CGI_Dir} ||= cwd;
						$Global{CGI_Dir} ||= ".";
			}
			$Global{CGI_Dir} =~ s/\\/\//g;
			if (!$Global{CGI_URL}) {
					$http = "http://"; $Domain = ""; $Script_URL = "";
					if ($ENV{HTTP_REFERER}) {if ($ENV{HTTP_REFERER} =~ m|^https://|i) {$http = "https://";}}
					if ($ENV{HTTP_HOST}) {$Domain = $http . $ENV{HTTP_HOST};}
					if ($ENV{SCRIPT_NAME}) {$Script_URL = $Domain . $ENV{SCRIPT_NAME};}
					@Temp = split (/[\/\\]/, $Script_URL);
					pop @Temp;
					$Global{CGI_URL} = join ('/', @Temp);
			}
			unshift @INC, $Global{CGI_Dir};
}
#==========================================================
eval "use GD;";
if ($@) {
	print "Error loading perl module GD $!\n<br>@INC<br>\n";
	exit 0;
}
#==========================================================
$GifFile = "$Global{CGI_Dir}/test.gif";
$GifOutFile = "$Global{CGI_Dir}/output.gif";

print "GD Module Version ". $GD::VERSION . ". Required 2.19 at least<br><br> \n\n";

print "<b>GIF Test</b>  <br>\n";
print "----------------<br>\n";
print "File: $GifFile <br><br>\n\n";
&Test_GIF($GifFile, $GifOutFile);

print "<br><br>\n\n";
$JpegFile = "$Global{CGI_Dir}/test.jpg";
$JpegOutFile = "$Global{CGI_Dir}/output.jpg";
print "<b>JPG Test</b>  <br>\n";
print "----------------<br>\n";
print "File: $JpegFile <br><br>\n\n";
&Test_JPG($JpegFile, $JpegOutFile);

print "<br><br>\n\n";
$PngFile = "$Global{CGI_Dir}/test.png";
$PngOutFile = "$Global{CGI_Dir}/output.png";
print "<b>PNG Test</b>  <br>\n";
print "----------------<br>\n";
print "File: $JpegFile <br><br>\n\n";
&Test_PNG($PngFile, $PngOutFile);

print "<br><br>\n\nDone...\n\n";
exit 0;
#==========================================================
sub Test_JPG{
my ($File, $OutFile) = @_;
my ($srcImage, $Thumb);

	#------------------------------------------------------
	if (! open(IN, "$File")) {
		print "Can 't read image file $File: $! <br>\n";
		return;
	}
	#------------------------------------------------------
	print "Trying to read the Jpeg graphics file with GD ...<br>\n";
	if ($srcImage = GD::Image->newFromJpeg(\*IN)) {
			print "I can read Jpeg file<br>\n";
			close IN;
	}
	else{
			print "I can not read Jpeg file, aborting Jpeg test: $!<br>\n";
			close IN;
			return;
	}
	#------------------------------------------------------
	print "<br>\nTrying to create new JPG image <br>\n";
	if ($Thumb = new GD::Image(200, 200) ) {
			print "I can create JPG images <br>\n";
	}
	else{
			print "I can not create JPG images: $! <br>\n";
	}
	#------------------------------------------------------
	print "<br>\nTrying to resize JPG image <br>\n";
	$Thumb->copyResized($srcImage, 0, 0, 0, 0, 100, 100, 100, 100);
	print "Done resizing. <br>\n";
	#------------------------------------------------------
	print "<br>\nTrying to create JPG output file <br>\n";
	if (!open(File, ">$OutFile")) {
			print "Error creating output file: $! <br>\n";
	}
	binmode(File);
	if (print File $Thumb->jpeg) {
			print "I can write output JPG images <br>\n";
	}
	else{
			print "I can not write output JPG images: $! <br>\n";
	}
	close(File);
	#------------------------------------------------------

}
#==========================================================
sub Test_GIF{
my ($File, $OutFile) = @_;
my ($srcImage, $Thumb);

	#------------------------------------------------------
	if (! open(IN, "$File")) {
		print "Can 't read image file $File: $! <br>\n";
		return;
	}
	#------------------------------------------------------
	print "Trying to read the Gif graphics file with GD ...<br>\n";
	if ($srcImage = GD::Image->newFromGif(\*IN)) {
			print "I can read Gif file<br>\n";
			close IN;
	}
	else{
			print "I can not read Gif file, aborting GIF test: $!<br>\n";
			close IN;
			return;
	}
	#------------------------------------------------------
	print "<br>\nTrying to create new Gif image <br>\n";
	if ($Thumb = new GD::Image(200, 200) ) {
			print "I can create Gif images <br>\n";
	}
	else{
			print "I can not create Gif images: $! <br>\n";
			return;
	}
	#------------------------------------------------------
	print "<br>\nTrying to resize Gif image <br>\n";
	$Thumb->copyResized($srcImage, 0, 0, 0, 0, 100, 100, 100, 100);
	print "Done resizing.<br>\n";
	#------------------------------------------------------
	print "<br>\nTrying to create Gif output file <br>\n";
	if (!open(File, ">$OutFile")) {
			print "Error creating Gif output file: $! <br>\n";
	}
	binmode(File);
	if (print File $Thumb->jpeg) {
			print "I can  write output JPG images <br>\n";
	}
	else{
			print "I can not write output JPG images: $! <br>\n";
	}
	close(File);
	#------------------------------------------------------
}
#==========================================================
sub Test_PNG{
my ($File, $OutFile) = @_;
my ($srcImage, $Thumb);

	#------------------------------------------------------
	if (! open(IN, "$File")) {
		print "Can 't read image file $File: $! <br>\n";
		return;
	}
	#------------------------------------------------------
	print "Trying to read the Png graphics file with GD ...<br>\n";
	if ($srcImage = GD::Image->newFromPng(\*IN)) {
			print "I can read Png file<br>\n";
			close IN;
	}
	else{
			print "I can not read Png file, aborting Png test: $!<br>\n";
			close IN;
			return;
	}
	#------------------------------------------------------
	print "<br>\nTrying to create new Png image <br>\n";
	if ($Thumb = new GD::Image(200, 200) ) {
			print "I can create Png images <br>\n";
	}
	else{
			print "I can not create Png images: $! <br>\n";
	}
	#------------------------------------------------------
	print "<br>\nTrying to resize Png image <br>\n";
	$Thumb->copyResized($srcImage, 0, 0, 0, 0, 100, 100, 100, 100);
	print "Done resizing. <br>\n";
	#------------------------------------------------------
	print "<br>\nTrying to create Png output file <br>\n";
	if (!open(File, ">$OutFile")) {
			print "Error creating output file: $! <br>\n";
	}
	binmode(File);
	if (print File $Thumb->jpeg) {
			print "I can write output Png images <br>\n";
	}
	else{
			print "I can not write output Png images: $! <br>\n";
	}
	close(File);
	#------------------------------------------------------

}
#==========================================================
# newFromXbm ?
#==========================================================
